#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;
#define ALL(A) A.begin(), A.end()

int main(int argc, char** argv) {
    registerGen(argc, argv, 1);

    bool delicate = false;
    
    if (argv[1] == string("delicate"))
        delicate = true, ++argv;    
    
    int p = atoi(argv[1]);
    int n = atoi(argv[2]);
    int d = atoi(argv[3]);
    int b = atoi(argv[4]);
    
    argv += 4;

    vector<int> proportions(6);
    
    if (argv[1] == string("randomize")) {
        d = rnd.next(1, d);
        b = rnd.next(1, b);
        ++argv;

        while (std::accumulate(ALL(proportions), 0) == 0)
            for (int i = 0; i != 6; ++i) {
                proportions[i] = rnd.next(0, 3);
                proportions[i] = min(proportions[i], rnd.next(0, 3));
            }
    } else {
        for (int i = 0; i != 6; ++i)
            proportions[i] = atoi(argv[1 + i]);

        argv += 6;
    }

    vector<int> a(n);

    if (delicate) {
        vector<int> psums(7);
        for (int i = 0; i != 6; ++i)
            psums[i + 1] = psums[i] + proportions[i];

        for (int t = 0; t != n * b; ++t) {
            int j = std::upper_bound(ALL(psums), rnd.next(0, psums[6] - 1)) - psums.begin() - 1;
            a[min(n - 1, j * (n / 6) + rnd.next(0, n / 6))] += 1;
        }
    } else {
        int total = std::accumulate(ALL(proportions), 0);
        vector<int> divided(6);

        for (int i = 0; i != 6; ++i)
            divided[i] += proportions[i] * int64_t(n * b) / total;

        int left = n * b - accumulate(ALL(divided), 0);
        while (left > 0)
            divided[rnd.next(0, 5)] += 1, left -= 1;

        auto distribute = [&](int l, int r, int w) {
            // [l; r] = [0; r - l]
            
            vector<int> psums(r - l + 2);
            psums[0] = 0;
            psums[r - l + 1] = w;

            for (int i = 1; i <= r - l; ++i)
                psums[i] = rnd.next(0, w);

            std::sort(ALL(psums));
            for (int i = 0; i <= r - l; ++i)
                a[l + i] = psums[i + 1] - psums[i];
        };

        for (int i = 0; i != 6; ++i)
            distribute(i * (n / 6), (i == 5 ? n - 1 : (i + 1) * (n / 6) - 1), divided[i]);
    }
    
    cout << p << " " << n << " " << d << " " << b << "\n";

    for (int i = 0; i != n; ++i)
        cout << a[i] << " \n"[i == n - 1];
}
