#include <bits/stdc++.h>
using namespace std;
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define fore(i, b, e) for (int i = (int)(b); i <= (int)(e); ++i)
#define ford(i, n) for (int i = (int)(n) - 1; i >= 0; --i)
#define pb push_back
#define fi first
#define se second
#define all(x) (x).begin(), (x).end()
typedef vector<int> vi;
typedef pair<int, int> pii;
typedef long long i64;
typedef unsigned long long u64;
typedef long double ld;
typedef long long ll;

const int maxn = 100500;

int n, p, d, B;
int a[maxn];
int c[maxn], s[maxn];

int get(i64 l, i64 r) {
    return s[min(r, (i64)n)] - s[min(l, (i64)n)];
}

void scan() {
    cin >> p >> n >> d >> B;
    forn(i, n) cin >> a[i];
}

int solve(vi a, int n) {
    forn(i, a.size()) {
        c[i] = a[i];
        s[i+1] = s[i] + c[i];
    }

    int bef = 0, aft = 0;
    int res = 0;

    forn(i, n) {
        aft += get((i64)i * (d+1), (i64)(i+1)*(d+1));
        a[i] = 0;
        if (a[i] < B) {
            int fromBef = min(bef, B - a[i]);
            a[i] += fromBef;
            bef -= fromBef;
            if (a[i] + aft >= B) {
                aft -= B - a[i];
            } else {
                ++res;
            }
        } else {
            bef += a[i] - B;
        }
    }
    return res;
}

int best = 1e9;

bool f(int m) {
    int r1, r2;
    // cerr << "f(" << m << ")\n";

    {
        vi a;
        int r = m;
        forn(i, ::n) {
            int t = min(r, ::a[i]);
            a.push_back(t);
            r -= t;
        }
        r1 = solve(a, (n+1)/2);
        // for (auto x: a) cerr << x << " "; cerr << endl;
        // cerr << "r1 = " << r1 << endl;
        // cerr << endl;
    }

    {
        vi a;
        int r = m;
        forn(i, ::n) {
            int t = min(r, ::a[i]);
            a.push_back(t);
            r -= t;
        }
        r2 = solve(a, n/2);

        // for (auto x: a) cerr << x << " "; cerr << endl;
        // cerr << "r2 = " << r2 << endl;
        // cerr << endl;
    }
    // cerr << r1 << " " << r2 << endl;


    best = min(best, max(r1, r2));
    return r1 > r2;
}

void solve() {
    if (p == 1) {
        cout << solve(vi(a, a+n), n) << endl;
        return;
    }

    // fore(i, 0, n) cerr << f(i) << " "; cerr << endl;

    int l = 0, r = n*B;
    while (l+1 < r) {
        int m = (l+r)/2;
        if (f(m)) l = m;
        else r = m;
    }
    f(l);
    f(r);
    cout << best << endl;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif

    scan();
    solve();

#ifdef LOCAL
    cerr << "Time elapsed: " << clock() / 1000 << " ms" << endl;
#endif
    return 0;
}
