#include "testlib.h"
#include <bits/stdc++.h>

using namespace std;

#define ALL(A) A.begin(), A.end()
#define SZ(A) int(A.size())

void write_test(int p, int d, int b, const vector<int>& seq) {
    cout << p << " " << seq.size() << " " << d << " " << b << "\n";
    for (int i = 0; i != SZ(seq); ++i)
        cout << seq[i] << " \n"[i + 1 == SZ(seq)];
}

int main(int argc, char** argv) {
    registerGen(argc, argv, 1);
    
    int p = atoi(argv[1]);
    int n = atoi(argv[2]);

    int max_b = atoi(argv[3]);
    
    string md = argv[4];

    if (md == "worst") {
        n -= n % 2;
        
        int d = n - 1;
        int b = max_b / 2;

        vector<int> a;
        for (int i = 0; i != n / 2; ++i)
            a.push_back(0);

        for (int i = 0; i != n / 2; ++i)
            a.push_back(2 * b);
        
        write_test(p, d, b, a);        
    } else if (md == "compl") {
        int d = 0.666 * n;
        int b = max_b;
        
        vector<int> a(n);

        int64_t sum = 0;
        for (int i = n / 2 - 1; i != n - 1; ++i) {
            a[i] = rnd.next(int64_t(0), int64_t(1.9 * max_b));

            sum += a[i];
        }

        a[n - 1] = (int64_t(n) * b - sum);
        
        write_test(p, d, b, a);
    }
}
