#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int MX = 100 * 1000 + 7;

#define LEFT 0
#define RIGHT 1
#define DIR int

int a[MX];
ll ps[MX];
ll bal[MX];
ll prefBal[MX];
int p, n, d, B;

ll sm(ll l, ll r) {
    return prefBal[r] - prefBal[l - 1];
}

ll solve(int l, int r, ll bl, ll br, DIR dir) {
    if (dir == RIGHT) {
        l = n - 1 - l;
        r = n - 1 - r;
        swap(l, r);
    }
    for (int i = 0; i < n; i++) {
        ll before = ps[i], after = ps[i + 1] - 1;
        ll cbal = max(0ll, min(br, after) - max(bl, before) + 1);
        bal[i] = cbal;
    }

    if (dir == RIGHT) {
        reverse(bal, bal + n);
    }

    for (int i = 1; i <= n; i++) {
        prefBal[i] = prefBal[i - 1] + bal[i - 1];
    }

    ll front = 0;
    for (int i = l; i <= r; i++) {
        if (front > 0) {
            ll here = min(bal[i], front);
            bal[i] -= here;
            front -= here;
        }
        if (bal[i] < B) {
            int pos = min(ll(n), i + ll(d) * (i + 1) + 1);
            if (sm(i + 2, pos) + bal[i] - front >= B) {
                // can now put students
                front += B - bal[i];
                bal[i] = B;
                // put here and add other to front
            } else if (i + 1 <= r) {
                // can't put students add to front
                bal[i + 1] += bal[i];
                bal[i] = 0;
            } else {
                // everybody's here
                ll addedHere = sm(i + 2, pos) - front;
                bal[i] += addedHere;
                front += addedHere;
            }
        }
        if (bal[i] > B && i + 1 <= r) {
            // overflow
            ll more = bal[i] - B;
            bal[i + 1] += more;
            bal[i] = B;
        }
    }

    for (int i = r + 1; i <= n; i++) {
        if (front <= 0) {
            break;
        }
        ll addHere = min(front, bal[i]);
        bal[i] -= addHere;
        front -= addHere;
    }

    int angryTimes = 0;
    for (int i = l; i <= r; i++) {
        if (bal[i] < B) {
            angryTimes++;
        }
    }
    return angryTimes;
}

ll diff(ll x) {
    return solve(0, (n + 1) / 2 - 1, 0, x - 1, LEFT) - solve((n + 1) / 2, n - 1, x, ps[n] - 1, RIGHT);
}

ll calc(ll x) {
    return max(solve(0, (n + 1) / 2 - 1, 0, x - 1, LEFT), solve((n + 1) / 2, n - 1, x, ps[n] - 1, RIGHT));
}

int main() {
#ifdef NIZNIY_MAGAZIN_MIR_V_CENTRE_VINNITSY
    freopen("in", "r", stdin);
#endif
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    cin >> p >> n >> d >> B;
    ll sm = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        sm += a[i];
    }
    for (int i = 1; i <= n; i++) {
        ps[i] = ps[i - 1] + a[i - 1];
    }

    if (p == 1) {
        cout << solve(0, n - 1, 0, sm - 1, LEFT) << endl;
        return 0;
    }

    ll ans = 0;
    ll l = 0, r = ps[n];
    while (r - l > 1) {
        ll m = (l + r) >> 1;
        if (diff(m) >= 0) {
            l = m;
        } else {
            r = m;
        }
        ans = calc(l);
        if (r != ps[n]) {
            ans = min(ans, calc(r));
        }
    }

    cout << ans << "\n";
}

