#include <bits/stdc++.h>
using namespace std;
using ll = long long;
using ld = long double;

int solve1(const vector<int>& a, int n, int d, int B) {
  int r = 0;
  ll cnt = 0;
  int res = 0;
  for (int i = 0; i < n; ++i) {
    ll to = min<ll>(n, i + d * ll(i + 1));
    for (int j = r; j <= to; ++j) {
      cnt += a[j];
    }
    r = to + 1;
    if (cnt < B) {
      ++res;
    } else {
      cnt -= B;
    }
  }
  return res;
}

signed main() {
#ifdef LOCAL
  assert(freopen("e.in", "r", stdin));
#endif
  ios::sync_with_stdio(false);
  cin.tie(0);


  int p, n, d, B;
  cin >> p >> n >> d >> B;
  vector<int> a(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i];
  }

  if (p == 1) {
    cout << solve1(a, n, d, B) << '\n';
  } else {
    int res1 = solve1(a, n / 2, d, B);
    reverse(a.begin(), a.end());
    int res2 = solve1(a, n - n / 2, d, B);
    cout << max(res1, res2) << '\n';
  }
}
